



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ES6新特性之 promise</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ES6新特性之 promise</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-11 10:32:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　新的ES6中引入了promise的概念，目的是让回调更为优雅。层层嵌套的回调会让javascript失去美感和可读性，同时javascript也推荐采用链式的方式去书写函数调用。于是Promise就应运而生。Promise即承诺的意思，new一个Promise就是新建一个承诺。在新建一个承诺的时候你需要做两件事情：</p>
<p>　　<strong>1.指定承诺所需完成的事</strong></p>
<p><strong>　　2.<strong>设置承诺是否实现的标准</strong></strong></p>
<p><strong>下面我们来定义一个承诺：</strong></p>
<p><strong>　　1.承诺的内容：&ldquo;</strong><em>获取data.php的数据</em><strong>&rdquo;，</strong></p>
<p><strong>　　2.<strong>承诺是否实现的评判是：</strong>&ldquo;</strong><em>是否获取data.php的数据</em><strong>&nbsp;&rdquo;</strong></p>
<p><strong>这里我们会用到jQuery.ajax()方法，这会让我们的代码显得简单精炼。</strong></p>
<div>
<pre class="prettyprint linenums">var http = {<br />
    get: function(url) {<br />
        var promise = new Promise(function(resolve, reject) {<br />
            $.ajax({<br />
                url: url,<br />
                method: 'get',<br />
                success: function(data) {<br />
                    resolve(data);<br />
                },<br />
                error: function(xhr, statusText) {<br />
                    reject(statusText);<br />
                }<br />
            });<br />
        });<br />
        return promise;<br />
    }<br />
};<br />
http.get('data.php').then(function(data) {<br />
    document.write(data);<br />
}, function(err) {<br />
    document.write(err);<br />
});
</pre>
</div>
<p>　　这里是获取的data值</p>
<div>
<pre class="prettyprint linenums">/* data.php文件 */<br />
&lt;?php<br />
echo '{"name":"Tom","age":"22"}';
</pre>
</div>
<p>　　在http请求中，我们定义了一个get方法，在get方法中，我们定义了一个promise的对象，而不是直接直接使用ajax获取到我们想要的数据，在这个get方法，我们最后得到的是一个promise对象，对于这种需要等待的操作，我们采用promise去处理，返回给主线程的是一个promise对象，而不是一个最终的数据，这是延迟程序给主程序的一个承诺，主线程可以根据通过返回的promise对象获取数据或者处理错误。这使得异步处理变得优雅而简单。</p>
<p>　　在jQuery.ajax()中，我们采用了两个方法来判断<strong>是否实现了我们的承诺，</strong>它们分别是resove和reject方法，如果如果jQuery.ajax()执行了success，并且返回的data中有数据，那么我们就判定这个承诺已经实现了（fulfilled），则调用resolve方法。如果jQuery.ajax()执行了error，那么我们就判定这个承诺被拒绝了（rejected），则调用reject方法。</p>
<p>那resove和reject这两个方法分别执行了哪些操作呢？这个我们就需要从Promise这个构造函数本身的结构说起。Promise这个构造函数结构大概是下面这样的：</p>
<div>
<pre class="prettyprint linenums">/* 用于描述思维的代码 */<br />
function Promise(executor) {<br />
    // 共有三种状态：pending（准备）、fulfilled（完成）、rejected（拒绝）<br />
    this.PromiseStatus = 'pending';<br />
    // 用于存储返回的数据<br />
    this.PromiseValue;<br />
    // 完成<br />
    var resolve = function(reson) {};<br />
    // 拒绝<br />
    var reject = function(reson) {};<br />
    ...<br />
    // 开始执行承诺<br />
    executor(resolve, reject);<br />
}<br />
Promise.prototype.then = function() {};<br />
Promise.prototype.chain = function() {};<br />
Promise.prototype.catch = function() {};<br />
...
</pre>
</div>
<p>　　</p>
<p><strong>PromiseStatus：</strong>用于记录Promise对象的三种状态，这三中状态分别是：<br /><em>pending：</em>待定状态，Promise对象刚被初始化的状态<br /><em>fulfilled：</em>完成状态，承诺被完成了的状态<br /><em>rejected：</em>拒绝状态，承诺完成失败的状态<br />Promise的初始状态是pending。随后会更具承诺完成的情况更改PromiseStatus的值。</p>
<p><strong>PromiseStatus：</strong>用于记录返回的数据或者错误。当承诺完成时，会把返回的数据赋给PromiseStatus。如果承诺执行失败了，那么失败的原因也会赋给此变量。</p>
<p><strong>resolve()和reject()：</strong>Promise构造函数中有两个闭包的函数resolve()和reject()。在new一个新的Promise的时候会传递一件你需要做的事情（executor）。这个executor是一个函数，在Promise的构造函数中它会被传入两个参数，这两个参数即我们的两个闭包的函数resolve()和reject()，以便你在executor中判定是否完成了你的承诺。</p>
<p><strong>executor()：</strong> executor()函数中执行的代码就是子程序需要完成事。在executor()函数内如果调用了resolve()，resolve()则会把Promise对象的状态PromiseStatus修改为fulfilled，把resolve(value)中的value值赋给Promise对象的PromiseValue。然后再依次执行由then()方法构成的回调链中的回调函数。同样，在executor()中调用reject()的过程也是类似的。调用过程如下：</p>
<pre class="prettyprint linenums"></pre>
<div>
<pre class="prettyprint linenums">/* 用于描述思维的代码 */<br />
executor(resolve, reject) {<br />
    ...<br />
    resolve(value);<br />
    ...<br />
}<br />
...<br />
resolve(value) {<br />
    PromiseStatus = 'fulfilled';<br />
    PromiseValue = value;<br />
    ...<br />
    // 接着调用回调链中的回调函数<br />
}
</pre>
</div>
<p>　　</p>
<p><strong>then(onFulfilled, onRejected)：</strong>这个方法实际上是把onFulfilled()函数和onRejected()函数添加到Promise对象的回调链中。回调链就像一个由函数组构成的队列，每一组函数都是由至少一个函数构成（onFulfilled() 或者 onRejected() 或者 onFulfilled() 和 onRejected()）。当resolve()或者reject()方法执行的时候，回调链中的回调函数会根据PromiseStatus的状态情况而被依次调用。</p>
<p><strong>onFulfilled(value)和onRejected(reason)：</strong>参数value和reason的实参都是PromiseValue。这里有一点值得注意，如果onFulfilled(value)和onRejected(reason)这两个回调函数中return返回值不是一个Promise的对象，那么这个返回值会被赋给PromiseValue，并在下一个then()的onFulfilled(value)和onRejected(reason)中做为实参使用。<strong><em>但如果这个返回值是一个Promise的对象，那么剩下的由then()构造的回调链会转交给新的Promise对象并完成调用。</em></strong></p>
<p>有这样一个问题，如果在第一个then()中执行了onRejected(reason)回调函数，并且没有return任何值的时候，那么下一个then()中将会调用onFulfilled(value)方法，而不是onRejected(reason)。因为在执行上一个then()的onRejected(reason)回调函数的时候并没有出现错误或异常，所以PromiseStatus的状态就被更改为fulfilled了。为了避免这个问题，我们可以在onRejected(reson)中返回一个Promise对象并reject()。代码如下，我们要去访问一个并不存在的文件solve.php：</p>
<div>
<pre class="prettyprint linenums">var http = {<br />
    get: function(url) {<br />
        var promise = new Promise(function(resolve, reject) {<br />
            $.ajax({<br />
                url: url,<br />
                method: 'get',<br />
                success: function(data) {<br />
                    resolve(data);<br />
                },<br />
                error: function(xhr, statusText) {<br />
                    reject(statusText);<br />
                }<br />
            });<br />
        });<br />
        return promise;<br />
    }<br />
};<br />
http.get('solve.php').then(function(data) {<br />
    return data;<br />
}, function(err) {<br />
    return Promise.reject('Sorry, file not Found.');<br />
}).then(function(data) {<br />
    document.write(data);<br />
}, function(err) {<br />
    document.write(err);<br />
});
</pre>
</div>
<p>　　Promise.reject()方法会返回一个被reject()的Promise对象，因此使得我们可以继续走下一个then()中的onRejected(reason)方法。</p>
<p>这个是对于promise的一些终结，参考了道友们的思考，原文链接：http://www.jianshu.com/p/87183851756f</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/4qndl7g8.html">Apache与Nginx对客户端请求的处理机制对比</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93ngnnq.html">H&colon;Highways</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93gw4n8.html">Mina、Netty、Twisted一起学（六）：session</a>
		</li>
						<li><a href="https://www.batexi.com/a/495vygeq.html">GCD-Grand Central Dispatch</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyzp129.html">TFS 2015 Update 2功能探索</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mndw62q.html">通过HTTP头控制浏览器的缓存</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o4pm39.html">MyEclipse设置默认的目光格式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w7n6oq.html">ThinkPad x200为何总是CPU占用50&percnt;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vg6e8.html">Spring Boot  注解详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj03oe9.html">【Netty源码分析】客户端connect服务端过程</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eylkxz9.html">SOFA 源码分析 &mdash; 扩展机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k1k1z9.html">2019前端面试题之js</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r54p5dq.html">炎黄流程中改流程节点颜色的js</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j161nl9.html">记一次CPU占用率和load高的排查</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyzj619.html">学习笔记8&mdash;MATLAB中奇异值处理办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25421oq.html">wx小程序功能总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql1jey09.html">Gym 100646 You&rsquo;ll be Working on the Railroad dfs</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p7xog8.html">2018&period;07&period;30 cogs2632&period; &lbrack;HZOI 2016&rsqb; 数列操作d（线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwl6pjr9.html">System&period;Drawing&period;Color的颜色对照表</a>
		</li>
						<li><a href="https://www.batexi.com/a/q44y7n5q.html">Tornado之架构概述图</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/4qnjewk8.html">关于 Lo、Hi、LoWord、HiWord</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96pwoj8.html">Scrum项目7&period;0</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zon41q.html">mac homebrew的用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjoj28.html">从倒影说起，谈谈 CSS 继承 inherit（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4z0m39.html">浅谈我对 jQuery 的了解</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnjo4k8.html">bzoj1026数位dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93ymjz8.html">jsonp帮助你知道你关注的他或她喜欢什么歌曲</a>
			</li>
						<li><a href="https://www.batexi.com/a/390moxj8.html">spring里的controller之间的跳转</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pdz4y9.html">最长下降子序列O&lpar;n&Hat;2&rpar;及O&lpar;n&ast;log&lpar;n&rpar;&rpar;解法</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qwj7ry8.html">Android 网络状态检测</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
